package com.community.pocket.data.main.visitor;

import androidx.lifecycle.MutableLiveData;

import com.community.pocket.data.model.LocalToken;
import com.community.pocket.ui.main.ui.visitor.my.VisitorMyResponse;
import com.community.pocket.util.HttpRequest;
import com.community.pocket.util.HttpUtil;
import com.community.pocket.util.SimpleHttpParse;

import okhttp3.FormBody;

/**
 * 我的访客请求接口
 */
public class VisitorMyRequest {
    private static volatile VisitorMyRequest instance;

    private VisitorMyRequest() {
    }

    public static VisitorMyRequest getInstance() {
        if (instance == null) {
            instance = new VisitorMyRequest();
        }
        return instance;
    }

    /**
     * 加载我的访客
     */
    @HttpRequest("/visitor/my")
    public void loadMy(MutableLiveData<VisitorMyResponse> liveData) {
        HttpUtil.getRequest(HttpUtil.Method.GET,
                new SimpleHttpParse<VisitorMyResponse>(liveData).getInterface(VisitorMyResponse.class),
                new FormBody.Builder()
                        .add("username", LocalToken.getUsername())
                        .add("token", LocalToken.getToken())
                        .build());
    }
}
