package com.community.pocket.ui.main.ui.forum.post;

import androidx.lifecycle.MutableLiveData;

import com.community.pocket.R;
import com.community.pocket.util.ValidUtil;

public class ForumPostActiveViewModel extends ForumPostViewModel {

    //表单校验状态
    private MutableLiveData<ForumPostFormState.Active> forumPostFormState = new MutableLiveData<>();

    MutableLiveData<ForumPostFormState.Active> getForumPostFormState() {
        return forumPostFormState;
    }

    //校验表单状态
    void postDataForumChanged(String title, String content, String activeStartTime, String activeEndTime, String activeScore) {
        if (!ValidUtil.titleValid(title)) {
            forumPostFormState.setValue(new ForumPostFormState.Active(R.string.invalid_title, null, null, null, null));
        } else if (!ValidUtil.notesValid(content)) {
            forumPostFormState.setValue(new ForumPostFormState.Active(null, R.string.invalid_post, null, null, null));
        } else if (!ValidUtil.dateValid(activeStartTime)) {
            forumPostFormState.setValue(new ForumPostFormState.Active(null, null, R.string.invalid_date, null, null));
        } else if (!ValidUtil.dateValid(activeEndTime)) {
            forumPostFormState.setValue(new ForumPostFormState.Active(null, null, null, R.string.invalid_date, null));
        } else if (!ValidUtil.before(activeStartTime, activeEndTime)) {
            forumPostFormState.setValue(new ForumPostFormState.Active(null, null, null, R.string.invalid_date_before, null));
        } else if (!ValidUtil.scoreValid(activeScore)) {
            forumPostFormState.setValue(new ForumPostFormState.Active(null, null, null, null, R.string.invalid_score));
        } else {
            forumPostFormState.setValue(new ForumPostFormState.Active(true));
        }
    }

    //发帖请求状态
    void sendPost(String title, String content, String activeStartTime, String activeEndTime, String activeScore) {
        getRequest().sendActive(forumPostResponse, title, content, activeStartTime, activeEndTime, activeScore);
    }
}
