package com.community.pocket.ui.main.ui.forum.post;

import androidx.annotation.Nullable;

/**
 * 发送帖子表单状态
 */
class ForumPostFormState {
    @Nullable
    private Integer titleError;
    @Nullable
    private Integer contentError;

    private boolean isDataValid;

    ForumPostFormState(@Nullable Integer titleError, @Nullable Integer contentError) {
        this.titleError = titleError;
        this.contentError = contentError;
    }

    ForumPostFormState(boolean isDataValid) {
        this.isDataValid = isDataValid;
    }

    @Nullable
    Integer getTitleError() {
        return titleError;
    }

    @Nullable
    Integer getContentError() {
        return contentError;
    }

    boolean isDataValid() {
        return isDataValid;
    }

    static class Active extends ForumPostFormState {
        @Nullable
        private Integer activeStartTimeError;
        @Nullable
        private Integer activeEndTimeError;
        @Nullable
        private Integer activeScore;

        Active(boolean isDataValid) {
            super(isDataValid);
        }

        Active(@Nullable Integer titleError, @Nullable Integer contentError, @Nullable Integer activeStartTimeError, @Nullable Integer activeEndTimeError, @Nullable Integer activeScore) {
            super(titleError, contentError);
            this.activeStartTimeError = activeStartTimeError;
            this.activeEndTimeError = activeEndTimeError;
            this.activeScore = activeScore;
        }

        @Nullable
        Integer getActiveStartTimeError() {
            return activeStartTimeError;
        }

        @Nullable
        Integer getActiveEndTimeError() {
            return activeEndTimeError;
        }

        @Nullable
        Integer getActiveScore() {
            return activeScore;
        }
    }

    static class Complain extends ForumPostFormState {
        @Nullable
        private Integer complainError;

        Complain(@Nullable Integer titleError, @Nullable Integer contentError, @Nullable Integer complainError) {
            super(titleError, contentError);
            this.complainError = complainError;
        }

        Complain(boolean isDataValid) {
            super(isDataValid);
        }

        @Nullable
        Integer getComplainError() {
            return complainError;
        }
    }
}
